package com.baijiayun;

import android.Manifest;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;

import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Toast;

import com.baijiahulian.common.permission.AppPermissions;
import com.baijiayun.download.SimpleVideoDownloadActivity;
import com.baijiayun.livebase.context.LPConstants;
import com.baijiayun.playback.PlaybackActivity;
import com.baijiayun.video.NewVideoActivity;
import com.baijiayun.videoplayer.core.demo.R;

import io.reactivex.android.schedulers.AndroidSchedulers;


public class LauncherActivity extends AppCompatActivity {

    private EditText customDomainEt;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_launcher);

        customDomainEt = findViewById(R.id.custom_domain_et);

        findViewById(R.id.btn_new).setOnClickListener(v -> {
            BJYPlayerSDK.CUSTOM_DOMAIN = customDomainEt.getText().toString();
            startActivity(new Intent(LauncherActivity.this, NewVideoActivity.class));
        });

        findViewById(R.id.btn_playback).setOnClickListener(v -> {
            BJYPlayerSDK.CUSTOM_DOMAIN = customDomainEt.getText().toString();
            startActivity(new Intent(LauncherActivity.this, PlaybackActivity.class));
        });

        findViewById(R.id.btn_downloading).setOnClickListener(v -> {
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                        BJYPlayerSDK.CUSTOM_DOMAIN = customDomainEt.getText().toString();
                        Intent intent = new Intent(LauncherActivity.this, SimpleVideoDownloadActivity.class);
                        startActivity(intent);
                    } else {
                        AppPermissions.newPermissions(LauncherActivity.this)
                                .request(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                .observeOn(AndroidSchedulers.mainThread())
                                .subscribe(aBoolean -> {
                                    if (aBoolean) {
                                        BJYPlayerSDK.CUSTOM_DOMAIN = customDomainEt.getText().toString();
                                        Intent intent = new Intent(LauncherActivity.this, SimpleVideoDownloadActivity.class);
                                        startActivity(intent);
                                    } else {
                                        Toast.makeText(LauncherActivity.this, "没有获取读写sd卡权限", Toast.LENGTH_SHORT).show();
                                    }
                                });
                    }

                }
        );

        ((RadioGroup) findViewById(R.id.rg_env)).setOnCheckedChangeListener((group, checkedId) -> {
            if (checkedId == R.id.rg_env_product) {
                BJYPlayerSDK.DEPLOY_TYPE = LPConstants.LPDeployType.Product;
            } else if (checkedId == R.id.rg_env_beta) {
                BJYPlayerSDK.DEPLOY_TYPE = LPConstants.LPDeployType.Beta;
            } else {
                BJYPlayerSDK.DEPLOY_TYPE = LPConstants.LPDeployType.Test;
            }
        });

        ((CheckBox) findViewById(R.id.encryptCb)).setOnCheckedChangeListener((buttonView, isChecked) -> {
            BJYPlayerSDK.IS_ENCRYPT = isChecked;
        });

        ((CheckBox) findViewById(R.id.backgroundPlayCb)).setOnCheckedChangeListener((buttonView, isChecked) -> {
            App.isPlayBackground = isChecked;
        });

        ((CheckBox) findViewById(R.id.supportLoopCb)).setOnCheckedChangeListener((buttonView, isChecked) -> {
            App.isLoopPlay = isChecked;
        });

        ((CheckBox) findViewById(R.id.supportMemoryPlayCb)).setOnCheckedChangeListener((buttonView, isChecked) -> {
            App.isMemoryPlay = isChecked;
        });

    }
}
